"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Component = exports.Partial = exports.DefineDependencies = void 0;
require("@rhtml/renderer");
const lit_html_1 = require("@rxdi/lit-html");
const DefineDependencies = (...deps) => (injection) => {
    for (const [index, dep] of deps.entries()) {
        Object.defineProperty(deps, index, {
            get: () => (injection && injection.has(dep) ? injection.get(dep) : dep),
        });
    }
    return deps;
};
exports.DefineDependencies = DefineDependencies;
const Partial = (options) => (deps = []) => (state = () => ({})) => (loading) => (error) => (render = () => state) => (0, lit_html_1.Component)(Object.assign(Object.assign({}, options), { template() {
        return (0, lit_html_1.html) `
          <r-renderer
            .options=${{
            state: state.bind(this).call(this, deps),
            loading,
            error,
            deepCloneState: options.deepCloneState,
            render: (state, setState, shadowRoot) => {
                this.shadowRoot.append(shadowRoot);
                return render(deps)
                    .bind(this)
                    .call(this, state, setState, shadowRoot);
            },
        }}
          ></r-renderer>
        `;
    } }));
exports.Partial = Partial;
function Component({ Settings, Providers, State, Render, Loading, Error, }) {
    return (0, exports.Partial)(Settings)(Providers)(State)(Loading)(Error)(Render);
}
exports.Component = Component;
//# sourceMappingURL=index.js.map